//+------------------------------------------------------------------+
//|                                                  Heiken Ashi.mq4 |
//|                      Copyright c 2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//| For Heiken Ashi we recommend next chart settings ( press F8 or   |
//| select on menu 'Charts'->'Properties...'):                       |
//|  - On 'Color' Tab select 'Black' for 'Line Graph'                |
//|  - On 'Common' Tab disable 'Chart on Foreground' checkbox and    |
//|    select 'Line Chart' radiobutton                               |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 SkyBlue
#property indicator_width1 1
#property indicator_width2 1






extern bool  alertsOn        = true;
extern bool  alertsOnCurrent = false;
extern bool  alertsMessage   = true;
extern bool  alertsSound     = false;
extern bool  alertsEmail     = false;





double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double trend[];





int init()
  {
   IndicatorBuffers(5);
   SetIndexBuffer(0, ExtMapBuffer3);
   SetIndexBuffer(1, ExtMapBuffer4); 
   SetIndexBuffer(2, ExtMapBuffer1); 
   SetIndexBuffer(3, ExtMapBuffer2); 
   SetIndexBuffer(4, trend);

   return(0);
  }



int start()
  {
   double haOpen, haClose, haLow, haHigh;
   int    counted_bars=IndicatorCounted();
   int    pos,limit;

   //
   //
   //
   //
   //
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;       
          
   //
   //
   //
   //
   //
   
          for(pos=limit; pos >= 0; pos--)
          {
          haClose = (Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
          haOpen  = (ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
          haHigh  = MathMax(High[pos], MathMax(haOpen,haClose));
          haLow   = MathMin(Low[pos],  MathMin(haOpen,haClose));

         if (haOpen<haClose) 
         { 
         ExtMapBuffer1[pos] = haLow;  
         ExtMapBuffer2[pos] = haHigh; 
         } 
         else              
         { 
         ExtMapBuffer1[pos] = haHigh; 
         ExtMapBuffer2[pos] = haLow;  
         } 
         ExtMapBuffer3[pos] = haOpen;
         ExtMapBuffer4[pos] = haClose;                
     
         trend[pos] = trend[pos+1];
         if (ExtMapBuffer3[pos] > ExtMapBuffer4[pos]) trend[pos] = -1;
         if (ExtMapBuffer3[pos] < ExtMapBuffer4[pos]) trend[pos] =  1;
         }  
   
  
   
        if (alertsOn)
        {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("up");
         else  doAlert("down");       
   }

   //
   //
   //
   //
          
   return(0);
}





void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," heiken ashi trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," heiken ashi "),message);
             if (alertsSound)   PlaySound("good-bad-ugly.wav");
      }
}

//+------------------------------------------------------------------+